﻿// JavaScript Document
+function()
{
    /**
     *
     * @param url 请求URL
     * @param okcall 回调
     * @param data 传的参数，用“{"aa":1,"bb":2}”
     * @param bCache 数据是否缓存 可以不传
     * @param time 数据缓存时间 可以不传
     */
    getDataByURL = function (url, okcall, data, bCache, time) {
        if(buyer.sessionID)
            url += ";jsessionid=" + buyer.sessionID;
        if (bCache && !time && dicUrlTime)
        {
            dicUrlTime.set(url, 10);
        }
        if (bCache == null) {
            bCache = false;
        }
        if(data != null && (typeof data != "object"))
        {
            console.log(url +":参数不合法，请传入JSON对象");
            return;
        }
        if(data == null || data == "")
        {
            data = {};
        }
        if (bCache) {
            getUrlByTime(url, okcall, data, bCache, time);
        }
        else {
            getDataAjax(url, okcall, data, bCache, time);
        }
    }

    function getDataAjax(url, okcall, data, bCache, time) {
        if(bShowWaitingDialog){
            asuiModal.showLoading();
        }else{
            bShowWaitingDialog  = true;
        }
        var timestamp = new Date().getTime();
        if(data && (typeof data == "object"))
        {
            data["timestamp"] = timestamp;
            data['clientVer']= getCurVer();
        }
        if(true)
        {
            var str = "";
            for(var obj in data)
            {
                str += obj +"=" + data[obj] + "&";
            }
            str =  str.substr(0,str.length - 1);
            console.log(url +"?" +str);
        }
        var timeout = 8000;
        if(url.indexOf("createOrder")  > -1 || url.indexOf("getPagingOrder")  > -1)
        {
            timeout = 30000;
        }
        $.ajax({
            type: 'post',
            url: url,
            data: data,
            timeout: timeout,
            success: function (object) {
                Log.d("http","success");
                if(okcall == null){
                    return;
                }
                var tempString;
                Log.d("http","object");
                if (object != null) {
                    if (object.code == 0) {
                        var objectTemp = object;
                        var dataJson;
                        if (object.data != null && object.data != "") {
                            dataJson = $.parseJSON(object.data);
                        }
                        if(dataJson)
                            objectTemp.data = dataJson;
                        okcall.apply(this, [objectTemp]);
                    }
                    else {
                        canClick = true;

                        if(typeof (object) == "string"){
                            if(object.indexOf("当前登录已失效，请重新登录！") >-1)
                            {
                                Log.d("http","autoLogin");
                                isLoginSuc = false;
                                showGlobalMessageDialog(hintVec.autologin);
                                autoLogin();
                            }

                        }else
                        {
                            if(object.message)
                            {
                                if(object.message.indexOf("获取用户ID失败!") >-1)
                                {
                                    window.location.href = "index.html";
                                }else{
                                    showGlobalMessageDialog(object.message);
                                }
                            }

                        }
                    }
                }
                if(bHideWaitingDialog){
                    asuiModal.removeLoading();
                }
            },
            error: function (err) {
                console.log("error");
                showGlobalMessageDialog(hintVec.connectServerFail);
                asuiModal.removeLoading();
            }
        });
    };

    function getUrlByTime(url, okcall, data, bCache, time) {
        if(bWeixinAndroid){
            getLocalStorage(localJavaUrl,url+data,function(dataJson){
                if(dataJson)
                {
                    var tempTime = dataJson.time;
                    if(tempTime != null && tempTime > 0)
                    {
                        okcall.apply(this, [$.parseJSON(dataJson.data)]);
                        alertZ("cacheLO");
                    }
                }else
                {
                    getDataAjax(url, okcall, data, bCache, time);
                }
            })
        }else{
            select(tableUrl, "data,time", "url=?", [url+data], function (rows) {
                if (rows) {
                    var time = rows.item(0).time;
                    if (time != null && time > 0) {
                        okcall.apply(this, [$.parseJSON(rows.item(0).data)]);
                        alertZ("cacheSQL");
                    }
                }
                else {
                    getDataAjax(url, okcall, data, bCache, time);
                }
            });
        }
    }

// 缓存默认时间
    var dicUrlTime = "";
    function subUrlTime() {
        if(bWeixinAndroid){
            selectLocalStorage(localJavaUrl,"time",function(data){
                if(data)
                {
                    for(var i = 0 ; i< data.length ; i++)
                    {
                        var time = --data[i].time;
                        if(time == 0)
                        {
                            removeLocalStorage(localJavaUrl,data[i].key);
                        }else
                        {
                            setLocalStorage(localJavaUrl, data[i].key,['time'], [time]);
                        }
                    }
                }
            });
        }else{
            select(tableUrl, "time, url", "", null, function (rows) {
                if (rows) {
                    for (var i = 0; i < rows.length; i++) {
                        var time = --rows.item(i).time;
                        if (time == 0) {
                            deleteRow(tableUrl, "url=?", [rows.item(i).url]);
                        }
                        else {
                            saveOrUpdate(tableUrl, ['time'], [time], 'url', rows.item(i).url);
                        }
                    }
                }
            });
        }
    }


}();
