﻿var localJavaUrl = "localUrl_";//缓存后端通信数据
var localcount = "localcount_";//缓存购物车
var localBuyList = "localBuyList_";//最近购买记录缓存
var localBreakfast = "localBreakfast_";//缓存早餐购物车
var localNight = "localNight_";//缓存夜店购物车
var localMessage = "localMessage_"//学校公告
var localMessageCount = "localMessageCount_"//学校公告弹窗次数

var localStorageUtils ={
    /**
     * 获取本地缓存数据
     * @param key
     * @param areaId 学校id 可以不传
     * @returns {*}
     */
    getLocal:function (key,areaId) {
        var data;
        if(this.isSupportLocalStorge())
        {
            areaId =  areaId  ? (areaId  +"_") : "";
            data = window.localStorage.getItem(areaId + key);
            if(data == null){
                return "";
            }else{
                return data;
            }
        }else{
            areaId = areaId ? areaId : "common";
            data = getLocalOnAndroid(key,areaId);
            if(data == null){
                return "";
            }else{
                return data;
            }
        }
    },
    /**
     * 设置本地缓存数据
     * @param key
     * @param 值
     * @param areaId 学校id 可以不传
     */
    setLocal:function (key, value,areaId) {
        if(this.isSupportLocalStorge())
        {
            areaId =  areaId  ? (areaId  +"_") : "";
            window.localStorage.setItem(areaId + key, value +"");
        }else{
            areaId = areaId ? areaId : "common";
            setLocalOnAndroid(key, value +"",areaId);
        }


    },
    /**
     * 移除本地缓存
     * @param key
     * @param areaId 学校id 可以不传
     */
    removeLocal:function(key,areaId)
    {
        areaId =  areaId  ? (areaId  +"_") : "";
        if(this.isSupportLocalStorge()){
            window.localStorage.removeItem(areaId + key);
        }else{
            areaId = areaId ? areaId : "common";
            removeLocalOnAndroid(key,areaId);
        }
    },
    /**
     * @module 区别不同模块的数据
     * @key  键值
     * @insertFields 参数名数组
     * @insertParams 参数数组
     * @param areaId 学校id 可以不传
     */
    setLocalStorage:function(module,key,insertFields,insertParams,areaId)
    {
        var value = new Object();
        var oldData;
        areaId =  areaId  ? ("_" + areaId  +"_") : "";
        oldData = window.localStorage.getItem(module + areaId + key);
        //var oldData = getCookie(module,key);
        if(oldData)
        {
            var oldJson = $.parseJSON(oldData);
            for(var i in oldJson)
            {
                value[i] = oldJson[i];
            }
        }

        if((insertFields instanceof Array) && (insertParams instanceof  Array) && insertFields.length == insertParams.length)
        {
            for(var i = 0 ; i < insertFields.length ; i ++)
            {
                value[insertFields[i]] = insertParams[i];
            }
        }else
        {
            return;
        }

        window.localStorage.setItem(module + areaId + key, JSON.stringify(value));
    },
    /**
     *
     * @param module 区别不同模块的数据
     * @param key 键值
     * @param areaId 学校id 可以不传
     */
    getLocalStorage:function(module,key,areaId)
    {
        areaId =  areaId  ? ("_" + areaId  +"_") : "";
        if(this.isSupportLocalStorge()){
            var data = window.localStorage.getItem(module + areaId + key);
            return $.parseJSON(data);
        }
    },
    /**
     *
     * @param module 区别不同模块的数据
     * @param key 键值
     * @param areaId 学校id 可以不传
     */
    removeLocalStorageByKey:function(module,key,areaId)
    {
        areaId =  areaId  ? ("_" + areaId  +"_") : "";
        if(this.isSupportLocalStorge()){
            window.localStorage.removeItem(module + areaId + key);
        }
    },
    /**
     *
     * @param module 区别不同模块的数据
     * @param areaId 学校id 可以不传
     */
    removeLocalStorageByModule:function(module,areaId)
    {
        areaId =  areaId  ? ("_" + areaId  +"_") : "";
        if(this.isSupportLocalStorge()){
            var key ;
            for(var i = 0 ; i <  window.localStorage.length ;i ++)
            {
                key = window.localStorage.key(i);
                if(key.indexOf(module) >= 0 && key.indexOf(areaId) >= 0)
                {
                    window.localStorage.removeItem(key);
                }
            }

        }
    },
    /**
     *
     * @param module 区别不同模块的数据
     * @param params 参数
     * @param areaId 学校id 可以不传
     */
    selectLocalStorage:function(module,params,areaId)
    {
        areaId =  areaId  ? ("_" + areaId  +"_") : "";
        if(this.isSupportLocalStorge())
        {
            var paramList;
            if(params)
            {
                if(String(params).indexOf(",") < 0)
                {
                    paramList = [params];
                }else
                {
                    paramList = String(params).split(",");
                }

            }
            var key ;
            var value;
            var dataJson;
            var data = new Array();
            for(var i = 0 ; i <  window.localStorage.length ;i ++)
            {
                key = window.localStorage.key(i);
                if(key.indexOf(module) >= 0 && key.indexOf(areaId) >= 0)
                {
                    value = window.localStorage.getItem(key);
                    if(value.indexOf("{") != -1 || value.indexOf("[") != -1)
                    {
                        dataJson =  $.parseJSON(value);
                        var obj;
                        if(paramList && paramList.length > 0)
                        {
                            for(var j = 0 ; j < paramList.length ; j ++ )
                            {
                                obj = new Object();
                                obj[paramList[j]] = dataJson[paramList[j]];
                                obj["key"] = key.substr(key.lastIndexOf("_") + 1);
                                data.push(obj);
                            }
                        }
                    }
                }
            }
            return data;
        }
    },
    /**
     * 清除所有local
     */
    clearAllLocal:function()
    {
        window.localStorage.clear();
    },
    /**
     * 是否支持LocalStorge
     * @returns {boolean}
     */
    isSupportLocalStorge:function()
    {
        var flag = true;
        /*try{
            if(window['localStorageUtils'])
            {
                flag = true;
            }
        }catch(e)
        {
            flag = false;
            console.log('This browser does not support localStorageUtils');
        }
        if(isLowAndroidVersion())
        {
            flag = false;
        }*/
        if(browser.os.AndroidNotWx && !debug)
        {
            flag = false;
        }else
        {
            flag = true;
        }
        return flag;
    },
}
